
/*Checking when back is pressed*/
(function() {
    window.addEventListener('tizenhwkey', function(ev) {
        if (ev.keyName === 'back') {
            var page = document.getElementsByClassName('ui-page-active')[0],
                pageid = page ? page.id : '';
            if (pageid === 'main') {
                try {
                    var p = prompt("Exit?", "");
                    if (p !== null) {
                        tizen.application.getCurrentApplication().exit();
                    }

                } catch (ignore) {}
            } else {
                window.history.back();
            }
        }
    });
}());


//If user accepts permission, onSuccess() will be executed.
function onSuccess() {
    var measure_click = document.getElementById('start');
    measure_click.addEventListener('click', function() {
        tizen.power.request("SCREEN", "SCREEN_NORMAL"); //Keep display on while measuring.
        document.getElementById('heartrate').textContent = "Measuring...";
        //Detect Heart Rate
        function onchangedCB(hrmInfo) {
            if (hrmInfo.heartRate <= 0){
            	onchangedCB();
            }     
            else {
                document.getElementById('heartrate').textContent = hrmInfo.heartRate;
                var date_key = new Date();
                localStorage.setItem(date_key, hrmInfo.heartRate);  //Store heart rate according to time stamp in local storage.
                tizen.preference.setValue('KEY', hrmInfo.heartRate);   //Set a preference for app and widget communication.
                tizen.humanactivitymonitor.stop('HRM'); //Stop sensor.
                sleep(2000);
                tizen.power.release("SCREEN");
            }
        }
        tizen.humanactivitymonitor.start('HRM', onchangedCB); //Start Heart Rate Monitor Sensor.
    });

    //Show current date's heart rate history.
    var today_click = document.getElementById('today');
    today_click.addEventListener('click', function() {
        var i = localStorage.length - 1;
        if (i < 0) {
            document.getElementById('todayhistory').textContent = "No Data Available";
        } else {
            document.getElementById('todaylist').textContent = "";
            document.getElementById('todayhistory').textContent = "";
            var date = new Date();
            while (i >= 0) {
                var lastdate = new Date(localStorage.key(i));
                //Show data in a list view.
                if (lastdate.getDate() == date.getDate() && lastdate.getMonth() == date.getMonth()) {
                    var node = document.createElement("LI");
                    var textnode = document.createTextNode(localStorage.key(i).substring(3, 10) + " :" + localStorage.getItem(localStorage.key(i)));
                    node.appendChild(textnode);
                    document.getElementById("todaylist").appendChild(node);
                } else {
                    document.getElementById('todayhistory').textContent = "No Data Available";
                    break;
                }
                i--;
            }

        }

    });


    //Show current week's heart rate history.
    var lastweek_click = document.getElementById('last-week');
    lastweek_click.addEventListener('click', function() {
        var i = localStorage.length - 1;
        if (i < 0) {
            document.getElementById('last-weekhistory').textContent = "No Data Available";
        } else {
            document.getElementById('last-weekhistory').textContent = "";
            Date.prototype.getWeek = function() { //Get current week.
                var week_cal = new Date(this.getFullYear(), 0, 1);
                return Math.ceil((((this - week_cal) / 86400000) + week_cal.getDay() + 1) / 7);
            };
            var date = new Date();
            while (i >= 0) {
                var lastdate = new Date(localStorage.key(i));
                if (lastdate.getWeek() == date.getWeek() && lastdate.getMonth() == date.getMonth()) {
                    var node = document.createElement("LI");
                    var textnode = document.createTextNode(localStorage.key(i).substring(3, 10) + " :" + localStorage.getItem(localStorage.key(i)));
                    node.appendChild(textnode);
                    document.getElementById("weeklist").appendChild(node);
                } else {
                    document.getElementById('last-weekhistory').textContent = "No Data Available";
                    break;
                }
                i--;
            }
        }
    });

    //Show current month's heart rate history.
    var lastmonth_click = document.getElementById('last-month');
    lastmonth_click.addEventListener('click', function() {
        var i = localStorage.length - 1;
        if (i < 0) {
            document.getElementById('last-monthhistory').textContent = "No Data Available";
        } else {
            document.getElementById('last-monthhistory').textContent = "";
            var date = new Date();
            while (i >= 0) {
                var lastdate = new Date(localStorage.key(i));
                if (lastdate.getMonth() == date.getMonth()) {
                    var node = document.createElement("LI");
                    var textnode = document.createTextNode(localStorage.key(i).substring(3, 10) + " :" + localStorage.getItem(localStorage.key(i)));
                    node.appendChild(textnode);
                    document.getElementById("monthlist").appendChild(node);
                    document.getElementById("monthlist").refresh();
                } else {
                    document.getElementById('last-monthhistory').textContent = "No Data Available";
                    break;
                }
                i--;
            }

        }

    });
}

//If user denied permission, onError() will be executed.
function onError(e) {
    console.log("error " + JSON.stringify(e));
}

tizen.ppm.requestPermission("http://tizen.org/privilege/healthinfo", onSuccess, onError); //Invoke pop up for user's permission.

//Launch page from widget
window.onload = function() {
    if (tizen.preference.exists('launch_measure_page')) { //Check if user taps to open heart rate measuring page
        tau.changePage("#measure-page");
        tizen.preference.removeAll();
    }
    if (tizen.preference.exists('launch_history_page')) { //Check if user taps to open history page
        tau.changePage("#history-page");
        tizen.preference.removeAll();
    }
}